try:
    from DateTime import *
except:
    print "In order to use date.py you need the mxdatetime package"
    sys.exit()

today = (now()+RelativeDateTime(hour=0,minute=0,second=0))

##################################################################
# DayExt(), MonthExt(), YearExt(), WeekExt() #####################
##################################################################

def DayExt(days=1,offset=0):
    # first find this and next day
    this = (today + RelativeDateTime(days=offset))
    next = (today + RelativeDateTime(days=offset + days))
    return emma.date() >= this.ticks() and emma.date() < next.ticks()

emma.register_func("DayExt",\
   "Args: numDays, offset\n\n"\
   "Returns True if the transaction happened\n"\
   "between today plus offset days and the\n"\
   "next numDays\n\n"\
   "Examples : \n"\
   "  DayExt(2)    - gets next 2 days\n"\
   "  DayExt(7,-7) - gets last 7 days\n"\
   "  DayExt(1,-7) - gets a week ago today\n");

# -1: Sunday
#  0: Monday
startOfWeekOffset = -1

def WeekExt(numWeeks=1,offset=0):
    # first find the first day of this and next week
    A = RelativeDateTime(days=7*offset-startOfWeekOffset)
    B = RelativeDateTime(days=7*(offset+numWeeks)-startOfWeekOffset)
    this = (today + RelativeDateTime(weekday=(Monday,0)) + A)
    next = (today + RelativeDateTime(weekday=(Monday,0)) + B)
#    print 'this:', this.tuple(), 'next:', next.tuple()
    return emma.date() >= this.ticks() and emma.date() < next.ticks()

emma.register_func("WeekExt",\
   "Args: numWeeks, offset\n\n"\
   "Returns True if the transaction happened\n"\
   "in the next <numWeeks> weeks offset by \n"\
   "<offset> weeks, starting on Monday\n\n"\
   "Examples : \n"\
   "  WeekExt(2)    - gets this and next weeks\n"\
   "  WeekExt(1,1)  - gets next weeks\n"\
   "  WeekExt(4,-4) - gets last 4 weeks");


def MonthExt(months=1,offset=0):
    # Find first day of this and next month
    this = (today+RelativeDateTime(months=offset,day=1))
    next = (today+RelativeDateTime(months=offset+months,day=1))
    return emma.date() >= this.ticks() and emma.date() < next.ticks()

emma.register_func("MonthExt",\
   "Args: numMonths, offset\n\n"\
   "Returns True if the transaction happened\n"\
   "in the next <numMonths> months offset by\n"\
   "<offset> weeks.\n\n"\
   "Examples : \n"\
   "  MonthExt(1,-1)  - gets last months transactions\n"\
   "  MonthExt(2,-1)  - gets last and this months\n"\
   "  MonthExt()      - gets this months transactions");

def YearExt(years=1,offset=0):
    this = DateTime(today.year+offset)
    next = DateTime(today.year+offset+years)
    return emma.date() >= this.ticks() and emma.date() < next.ticks()

emma.register_func("YearExt",\
   "Args: numYears, offset\n\n"\
   "Returns True if the transaction happened in\n"\
   "the next <numYears> year offset by <offset>\n"\
   "years.\n\n"\
   "Examples : \n"\
   "  YearExt()     - this years transactions\n"\
   "  YearExt(1,-1) - last years transactions\n"\
   "  YearExt(2,-4) - gets 2 years starting 4 years ago");

